# all files / src/layouts/ IndexLayout.js

11.81% Statements 17/144
0% Branches 0/81
0% Functions 0/16
11.81% Lines 17/144

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246
    247
    248
    249
    250
    251
    252
    253
    254
    255
    256
    257
    258
    259
    260
    261
    262
    263
    264
    265
    266
    267
    268
    269
    270
    271
    272
    273
    274
    275
    276
    277
    278
    279
    280
    281
    282
    283
    284
    285
    286
    287
    288
    289
    290
    291
    292
    293
    294
    295
    296
    297
    298
    299
    300
    301
    302
    303
    304
    305
    306
    307
    308
    309
    310
    311
    312
    313
    314
    315
    316
    317
    318
    319
    320
    321
    322
    323
    324
    325
    326
    327
    328
    329
    330
    331
    332
    333
    334
    335
    336
    337
    338
    339
    340
    341
    342
    343
    344
    345
    346
    347
    348
    349
    350
    351
    352
    353
    354
    355
    356
    357
    358
    359
    360
    361
    362
    363
    364
    365
    366
    367
    368
    369
    370
    371
    372
    373
    374
    375
    376
    377
    378
    379
    380
    381
    382
    383
    384
    385
    386
    387
    388
    389
    390
    391
    392
    393
    394
    395
    396
    397
    398
    399
    400
    401
    402
    403
    404
    405
    406
    407
    408
    409
    410
    411
    412
    413
    414
    415
    416
    417
    418
    419
    420
    421
    422
    423
    424
    425
    426
    427
    428
    429
    430
    431
    432
    433
    434
    435
    436
    437
    438
    439
    440
    441
    442
    443
    444
    445

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

    1×

     /**
     * IndexLayouts contain {@link OO.ui.TabPanelLayout tab panel layouts} as well as
     * {@link OO.ui.TabSelectWidget tabs} that allow users to easily navigate through the tab panels and
     * select which one to display. By default, only one tab panel is displayed at a time. When a user
     * navigates to a new tab panel, the index layout automatically focuses on the first focusable element,
     * unless the default setting is changed.
     *
     * TODO: This class is similar to BookletLayout, we may want to refactor to reduce duplication
     *
     *     @example
     *     // Example of a IndexLayout that contains two TabPanelLayouts.
     *
     *     function TabPanelOneLayout( name, config ) {
     *         TabPanelOneLayout.parent.call( this, name, config );
     *         this.$element.append( '<p>First tab panel</p>' );
     *     }
     *     OO.inheritClass( TabPanelOneLayout, OO.ui.TabPanelLayout );
     *     TabPanelOneLayout.prototype.setupTabItem = function () {
     *         this.tabItem.setLabel( 'Tab panel one' );
     *     };
     *
     *     var tabPanel1 = new TabPanelOneLayout( 'one' ),
     *         tabPanel2 = new OO.ui.TabPanelLayout( 'two', { label: 'Tab panel two' } );
     *
     *     tabPanel2.$element.append( '<p>Second tab panel</p>' );
     *
     *     var index = new OO.ui.IndexLayout();
     *
     *     index.addTabPanels ( [ tabPanel1, tabPanel2 ] );
     *     $( 'body' ).append( index.$element );
     *
     * @class
     * @extends OO.ui.MenuLayout
     *
     * @constructor
     * @param {Object} [config] Configuration options
     * @cfg {boolean} [continuous=false] Show all tab panels, one after another
     * @cfg {boolean} [autoFocus=true] Focus on the first focusable element when a new tab panel is displayed. Disabled on mobile.
     */
    OO.ui.IndexLayout = function OoUiIndexLayout( config ) {
    	// Configuration initialization
    	config = $.extend( {}, config, { menuPosition: 'top' } );

    	// Parent constructor
    	OO.ui.IndexLayout.parent.call( this, config );

    	// Properties
    	this.currentTabPanelName = null;
    	this.tabPanels = {};

    	this.ignoreFocus = false;
    	this.stackLayout = new OO.ui.StackLayout( {
    		continuous: !!config.continuous,
    		expanded: this.expanded
    	} );
    	this.$content.append( this.stackLayout.$element );
    	this.autoFocus = config.autoFocus === undefined || !!config.autoFocus;

    	this.tabSelectWidget = new OO.ui.TabSelectWidget();
    	this.tabPanel = new OO.ui.PanelLayout( {
    		expanded: this.expanded
    	} );
    	this.$menu.append( this.tabPanel.$element );

    	this.toggleMenu( true );

    	// Events
    	this.stackLayout.connect( this, { set: 'onStackLayoutSet' } );
    	this.tabSelectWidget.connect( this, { select: 'onTabSelectWidgetSelect' } );
    	if ( this.autoFocus ) {
    		// Event 'focus' does not bubble, but 'focusin' does
    		this.stackLayout.$element.on( 'focusin', this.onStackLayoutFocus.bind( this ) );
    	}

    	// Initialization
    	this.$element.addClass( 'oo-ui-indexLayout' );
    	this.stackLayout.$element.addClass( 'oo-ui-indexLayout-stackLayout' );
    	this.tabPanel.$element
    		.addClass( 'oo-ui-indexLayout-tabPanel' )
    		.append( this.tabSelectWidget.$element );
    };

    /* Setup */

    OO.inheritClass( OO.ui.IndexLayout, OO.ui.MenuLayout );

    /* Events */

    /**
     * A 'set' event is emitted when a tab panel is {@link #setTabPanel set} to be displayed by the index layout.
     * @event set
     * @param {OO.ui.TabPanelLayout} tabPanel Current tab panel
     */

    /**
     * An 'add' event is emitted when tab panels are {@link #addTabPanels added} to the index layout.
     *
     * @event add
     * @param {OO.ui.TabPanelLayout[]} tabPanel Added tab panels
     * @param {number} index Index tab panels were added at
     */

    /**
     * A 'remove' event is emitted when tab panels are {@link #clearTabPanels cleared} or
     * {@link #removeTabPanels removed} from the index.
     *
     * @event remove
     * @param {OO.ui.TabPanelLayout[]} tabPanel Removed tab panels
     */

    /* Methods */

    /**
     * Handle stack layout focus.
     *
     * @private
     * @param {jQuery.Event} e Focusing event
     */
    OO.ui.IndexLayout.prototype.onStackLayoutFocus = function ( e ) {
    	var name, $target;

    	// Find the tab panel that an element was focused within
    	$target = $( e.target ).closest( '.oo-ui-tabPanelLayout' );
    	for ( name in this.tabPanels ) {
    		// Check for tab panel match, exclude current tab panel to find only tab panel changes
    		if ( this.tabPanels[ name ].$element[ 0 ] === $target[ 0 ] && name !== this.currentTabPanelName ) {
    			this.setTabPanel( name );
    			break;
    		}
    	}
    };

    /**
     * Handle stack layout set events.
     *
     * @private
     * @param {OO.ui.PanelLayout|null} tabPanel The tab panel that is now the current panel
     */
    OO.ui.IndexLayout.prototype.onStackLayoutSet = function ( tabPanel ) {
    	// If everything is unselected, do nothing
    	if ( !tabPanel ) {
    		return;
    	}
    	// Focus the first element on the newly selected panel
    	if ( this.autoFocus && !OO.ui.isMobile() ) {
    		this.focus();
    	}
    };

    /**
     * Focus the first input in the current tab panel.
     *
     * If no tab panel is selected, the first selectable tab panel will be selected.
     * If the focus is already in an element on the current tab panel, nothing will happen.
     *
     * @param {number} [itemIndex] A specific item to focus on
     */
    OO.ui.IndexLayout.prototype.focus = function ( itemIndex ) {
    	var tabPanel,
    		items = this.stackLayout.getItems();

    	if ( itemIndex !== undefined && items[ itemIndex ] ) {
    		tabPanel = items[ itemIndex ];
    	} else {
    		tabPanel = this.stackLayout.getCurrentItem();
    	}

    	if ( !tabPanel ) {
    		this.selectFirstSelectableTabPanel();
    		tabPanel = this.stackLayout.getCurrentItem();
    	}
    	if ( !tabPanel ) {
    		return;
    	}
    	// Only change the focus if is not already in the current page
    	if ( !OO.ui.contains( tabPanel.$element[ 0 ], this.getElementDocument().activeElement, true ) ) {
    		tabPanel.focus();
    	}
    };

    /**
     * Find the first focusable input in the index layout and focus
     * on it.
     */
    OO.ui.IndexLayout.prototype.focusFirstFocusable = function () {
    	OO.ui.findFocusable( this.stackLayout.$element ).focus();
    };

    /**
     * Handle tab widget select events.
     *
     * @private
     * @param {OO.ui.OptionWidget|null} item Selected item
     */
    OO.ui.IndexLayout.prototype.onTabSelectWidgetSelect = function ( item ) {
    	if ( item ) {
    		this.setTabPanel( item.getData() );
    	}
    };

    /**
     * Get the tab panel closest to the specified tab panel.
     *
     * @param {OO.ui.TabPanelLayout} tabPanel Tab panel to use as a reference point
     * @return {OO.ui.TabPanelLayout|null} Tab panel closest to the specified
     */
    OO.ui.IndexLayout.prototype.getClosestTabPanel = function ( tabPanel ) {
    	var next, prev, level,
    		tabPanels = this.stackLayout.getItems(),
    		index = tabPanels.indexOf( tabPanel );

    	if ( index !== -1 ) {
    		next = tabPanels[ index + 1 ];
    		prev = tabPanels[ index - 1 ];
    		// Prefer adjacent tab panels at the same level
    		level = this.tabSelectWidget.findItemFromData( tabPanel.getName() ).getLevel();
    		if (
    			prev &&
    			level === this.tabSelectWidget.findItemFromData( prev.getName() ).getLevel()
    		) {
    			return prev;
    		}
    		if (
    			next &&
    			level === this.tabSelectWidget.findItemFromData( next.getName() ).getLevel()
    		) {
    			return next;
    		}
    	}
    	return prev || next || null;
    };

    /**
     * Get the tabs widget.
     *
     * @return {OO.ui.TabSelectWidget} Tabs widget
     */
    OO.ui.IndexLayout.prototype.getTabs = function () {
    	return this.tabSelectWidget;
    };

    /**
     * Get a tab panel by its symbolic name.
     *
     * @param {string} name Symbolic name of tab panel
     * @return {OO.ui.TabPanelLayout|undefined} Tab panel, if found
     */
    OO.ui.IndexLayout.prototype.getTabPanel = function ( name ) {
    	return this.tabPanels[ name ];
    };

    /**
     * Get the current tab panel.
     *
     * @return {OO.ui.TabPanelLayout|undefined} Current tab panel, if found
     */
    OO.ui.IndexLayout.prototype.getCurrentTabPanel = function () {
    	var name = this.getCurrentTabPanelName();
    	return name ? this.getTabPanel( name ) : undefined;
    };

    /**
     * Get the symbolic name of the current tab panel.
     *
     * @return {string|null} Symbolic name of the current tab panel
     */
    OO.ui.IndexLayout.prototype.getCurrentTabPanelName = function () {
    	return this.currentTabPanelName;
    };

    /**
     * Add tab panels to the index layout
     *
     * When tab panels are added with the same names as existing tab panels, the existing tab panels
     * will be automatically removed before the new tab panels are added.
     *
     * @param {OO.ui.TabPanelLayout[]} tabPanels Tab panels to add
     * @param {number} index Index of the insertion point
     * @fires add
     * @chainable
     */
    OO.ui.IndexLayout.prototype.addTabPanels = function ( tabPanels, index ) {
    	var i, len, name, tabPanel, item, currentIndex,
    		stackLayoutTabPanels = this.stackLayout.getItems(),
    		remove = [],
    		items = [];

    	// Remove tab panels with same names
    	for ( i = 0, len = tabPanels.length; i < len; i++ ) {
    		tabPanel = tabPanels[ i ];
    		name = tabPanel.getName();

    		if ( Object.prototype.hasOwnProperty.call( this.tabPanels, name ) ) {
    			// Correct the insertion index
    			currentIndex = stackLayoutTabPanels.indexOf( this.tabPanels[ name ] );
    			if ( currentIndex !== -1 && currentIndex + 1 < index ) {
    				index--;
    			}
    			remove.push( this.tabPanels[ name ] );
    		}
    	}
    	if ( remove.length ) {
    		this.removeTabPanels( remove );
    	}

    	// Add new tab panels
    	for ( i = 0, len = tabPanels.length; i < len; i++ ) {
    		tabPanel = tabPanels[ i ];
    		name = tabPanel.getName();
    		this.tabPanels[ tabPanel.getName() ] = tabPanel;
    		item = new OO.ui.TabOptionWidget( { data: name } );
    		tabPanel.setTabItem( item );
    		items.push( item );
    	}

    	if ( items.length ) {
    		this.tabSelectWidget.addItems( items, index );
    		this.selectFirstSelectableTabPanel();
    	}
    	this.stackLayout.addItems( tabPanels, index );
    	this.emit( 'add', tabPanels, index );

    	return this;
    };

    /**
     * Remove the specified tab panels from the index layout.
     *
     * To remove all tab panels from the index, you may wish to use the #clearTabPanels method instead.
     *
     * @param {OO.ui.TabPanelLayout[]} tabPanels An array of tab panels to remove
     * @fires remove
     * @chainable
     */
    OO.ui.IndexLayout.prototype.removeTabPanels = function ( tabPanels ) {
    	var i, len, name, tabPanel,
    		items = [];

    	for ( i = 0, len = tabPanels.length; i < len; i++ ) {
    		tabPanel = tabPanels[ i ];
    		name = tabPanel.getName();
    		delete this.tabPanels[ name ];
    		items.push( this.tabSelectWidget.findItemFromData( name ) );
    		tabPanel.setTabItem( null );
    	}
    	if ( items.length ) {
    		this.tabSelectWidget.removeItems( items );
    		this.selectFirstSelectableTabPanel();
    	}
    	this.stackLayout.removeItems( tabPanels );
    	this.emit( 'remove', tabPanels );

    	return this;
    };

    /**
     * Clear all tab panels from the index layout.
     *
     * To remove only a subset of tab panels from the index, use the #removeTabPanels method.
     *
     * @fires remove
     * @chainable
     */
    OO.ui.IndexLayout.prototype.clearTabPanels = function () {
    	var i, len,
    		tabPanels = this.stackLayout.getItems();

    	this.tabPanels = {};
    	this.currentTabPanelName = null;
    	this.tabSelectWidget.clearItems();
    	for ( i = 0, len = tabPanels.length; i < len; i++ ) {
    		tabPanels[ i ].setTabItem( null );
    	}
    	this.stackLayout.clearItems();

    	this.emit( 'remove', tabPanels );

    	return this;
    };

    /**
     * Set the current tab panel by symbolic name.
     *
     * @fires set
     * @param {string} name Symbolic name of tab panel
     */
    OO.ui.IndexLayout.prototype.setTabPanel = function ( name ) {
    	var selectedItem,
    		$focused,
    		tabPanel = this.tabPanels[ name ],
    		previousTabPanel = this.currentTabPanelName && this.tabPanels[ this.currentTabPanelName ];

    	if ( name !== this.currentTabPanelName ) {
    		selectedItem = this.tabSelectWidget.findSelectedItem();
    		if ( selectedItem && selectedItem.getData() !== name ) {
    			this.tabSelectWidget.selectItemByData( name );
    		}
    		if ( tabPanel ) {
    			if ( previousTabPanel ) {
    				previousTabPanel.setActive( false );
    				// Blur anything focused if the next tab panel doesn't have anything focusable.
    				// This is not needed if the next tab panel has something focusable (because once it is focused
    				// this blur happens automatically). If the layout is non-continuous, this check is
    				// meaningless because the next tab panel is not visible yet and thus can't hold focus.
    				if (
    					this.autoFocus &&
    					!OO.ui.isMobile() &&
    					this.stackLayout.continuous &&
    					OO.ui.findFocusable( tabPanel.$element ).length !== 0
    				) {
    					$focused = previousTabPanel.$element.find( ':focus' );
    					if ( $focused.length ) {
    						$focused[ 0 ].blur();
    					}
    				}
    			}
    			this.currentTabPanelName = name;
    			tabPanel.setActive( true );
    			this.stackLayout.setItem( tabPanel );
    			if ( !this.stackLayout.continuous && previousTabPanel ) {
    				// This should not be necessary, since any inputs on the previous tab panel should have been
    				// blurred when it was hidden, but browsers are not very consistent about this.
    				$focused = previousTabPanel.$element.find( ':focus' );
    				if ( $focused.length ) {
    					$focused[ 0 ].blur();
    				}
    			}
    			this.emit( 'set', tabPanel );
    		}
    	}
    };

    /**
     * Select the first selectable tab panel.
     *
     * @chainable
     */
    OO.ui.IndexLayout.prototype.selectFirstSelectableTabPanel = function () {
    	if ( !this.tabSelectWidget.findSelectedItem() ) {
    		this.tabSelectWidget.selectItem( this.tabSelectWidget.findFirstSelectableItem() );
    	}

    	return this;
    };